<div class="main-container">
  <div class="header-section">
    <app-page-header [pageInfo]="pageHeaderInfo"></app-page-header>
  </div>
  <div class="signup-form-container">
    <form [formGroup]="form" class="centered-form" (ngSubmit)="send()">
      <div class="form-content">
        <div class="columns is-multiline">
          <div class="column is-12-mobile is-6-tablet">
            <div class="field">
              <label class="label" for="firstname"><span i18n="@@form.firstname">First Name </span><span
                  class="required-field">*</span></label>
              <p class="control has-icons-right">
                <input id="firstname" class="input" type="text" formControlName="firstName"
                  (keyup)="toUppercase('firstName')"
                  [ngClass]="{'has-error': fieldIsInvalid('firstName'), 'is-valid': fieldIsValid('firstName')}">
                <span class="icon is-small is-right is-icon-success" *ngIf="fieldIsValid('firstName')">
                  <span class="fas fa-check-circle"></span>
                </span>
                <span class="icon is-small is-right is-icon-warning" *ngIf="fieldIsInvalid('firstName')">
                  <span class="fas fa-exclamation-circle"></span>
                </span>
              </p>

              <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('firstName')">
                <div *ngIf="firstName.errors['required']" i18n="@@form.errors.invalidFirstname">
                  You must enter your first name.
                </div>
                <div *ngIf="firstName.errors['pattern']" i18n="@@form.errors.forbiddenCharacters">
                  Special characters are forbidden.
                </div>
              </div>
            </div>
          </div>

          <div class="column is-12-mobile is-6-tablet">
            <div class="field">
              <label class="label" for="lastname"><span i18n="@@form.lastname">Last Name </span><span
                  class="required-field">*</span></label>
              <p class="control has-icons-right">
                <input id="lastname" class="input" type="text" formControlName="lastName"
                  (keyup)="toUppercase('lastName')"
                  [ngClass]="{'has-error': fieldIsInvalid('lastName'), 'is-valid': fieldIsValid('lastName')}">
                <span class="icon is-small is-right is-icon-success" *ngIf="fieldIsValid('lastName')">
                  <span class="fas fa-check-circle"></span>
                </span>
                <span class="icon is-small is-right is-icon-warning" *ngIf="fieldIsInvalid('lastName')">
                  <span class="fas fa-exclamation-circle"></span>
                </span>
              </p>

              <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('lastName')">
                <div *ngIf="lastName.errors['required']" i18n="@@form.errors.invalidLastname">
                  You must enter your last name.
                </div>
                <div *ngIf="lastName.errors['pattern']" i18n="@@form.errors.forbiddenCharacters">
                  Special characters are forbidden.
                </div>
              </div>
            </div>
          </div>

          <div class="column is-12-mobile is-6-tablet">
            <div class="field">
              <label class="label" for="email"><span i18n="@@form.email">Email </span><span
                  class="required-field">*</span></label>
              <p class="control has-icons-right">
                <input id="email" class="input" type="email" formControlName="email"
                  [ngClass]="{'has-error': fieldIsInvalid('email'), 'is-valid': fieldIsValid('email')}">
                <span class="icon is-small is-right is-icon-success" *ngIf="fieldIsValid('email')">
                  <span class="fas fa-check-circle"></span>
                </span>
                <span class="icon is-small is-right is-icon-warning" *ngIf="fieldIsInvalid('email')">
                  <span class="fas fa-exclamation-circle"></span>
                </span>
              </p>

              <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('email')">
                <div *ngIf="email.errors['required']" i18n="@@form.errors.missingEmail">
                  You must enter your email address.
                </div>

                <div *ngIf="email.errors['email']" i18n="@@form.errors.invalidEmail">
                  You must enter a valid email address.
                </div>
              </div>
            </div>
          </div>

          <div class="column is-12-mobile is-6-tablet">
            <div class="field">
              <label class="label" for="emailConfirmation"><span i18n="@@signup.emailConfirmation">Email confirmation
                </span><span class="required-field">*</span></label>
              <p class="control has-icons-right">
                <input id="emailConfirmation" class="input" type="email" formControlName="emailConfirmation"
                  [ngClass]="{'has-error': emailConfirmationError || fieldIsInvalid('emailConfirmation'), 'is-valid': !emailConfirmationError && fieldIsValid('emailConfirmation')}">
                <span class="icon is-small is-right is-icon-success"
                  *ngIf="!emailConfirmationError && fieldIsValid('emailConfirmation')">
                  <span class="fas fa-check-circle"></span>
                </span>
                <span class="icon is-small is-right is-icon-warning"
                  *ngIf="emailConfirmationError || fieldIsInvalid('emailConfirmation')">
                  <span class="fas fa-exclamation-circle"></span>
                </span>
              </p>

              <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('emailConfirmation')">
                <div *ngIf="emailConfirmation.errors['required']" i18n="@@signup.errors.missingConfirmationEmail">
                  You must confirm your email address.
                </div>

                <div *ngIf="emailConfirmation.errors['email']" i18n="@@form.errors.invalidEmail">
                  You must enter a valid email address.
                </div>
              </div>
              <div class="form-incorrect-field-message" *ngIf="emailConfirmationError">
                <div i18n="@@signup.errors.emailConfirmationError">
                  You must enter the same email address.
                </div>
              </div>
            </div>
          </div>

          <div class="column is-12-mobile is-6-tablet">
            <div class="field">
              <label class="label" for="password"><span i18n="@@signup.password">Password </span><span
                  class="required-field">*</span></label>
              <div class="password-rule">
                <span class="not-bold" i18n="@@signup.password.rule.intro">Your password must contain at least</span>:
                <span i18n="@@signup.password.rule.length">{{ passwordMinLength }} characters</span>
                , <span i18n="@@signup.password.rule.special">one special character</span>,
                <span i18n="@@signup.password.rule.uppercase">one uppercased character</span>,
                <span i18n="@@signup.password.rule.lowercase">one lowercased character</span>
                <span class="not-bold" i18n="@@signup.password.rule.and"> and </span>
                <span i18n="@@signup.password.rule.number">one number</span>.
              </div>
              <p class="control has-icons-right">
                <input id="password" class="input" type="password" formControlName="password"
                  [ngClass]="{'has-error': fieldIsInvalid('password'), 'is-valid': fieldIsValid('password')}">
                <span class="icon is-small is-right is-icon-success" *ngIf="fieldIsValid('password')">
                  <span class="fas fa-check-circle"></span>
                </span>
                <span class="icon is-small is-right is-icon-warning" *ngIf="fieldIsInvalid('password')">
                  <span class="fas fa-exclamation-circle"></span>
                </span>
              </p>

              <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('password')">
                <div *ngIf="password.errors['required']" i18n="@@form.errors.missingpassword">
                  You must enter a password.
                </div>

                <div *ngIf="password.errors['minlength']" i18n="@@form.errors.minLength">
                  Your password must at least contain {{ passwordMinLength }} characters.
                </div>

                <div *ngIf="password.errors['invalidCharacters']" i18n="@@form.errors.invalidCharacters">
                  Your password contains invalid characters.
                </div>

                <div *ngIf="password.errors['missingSpecialCharacters']" i18n="@@form.errors.missingSpecialCharacters">
                  Your password must contain at least one special character.
                </div>

                <div *ngIf="password.errors['missingUppercasedLetter']" i18n="@@form.errors.missingUppercasedLetter">
                  Your password must contain at least one uppercased character.
                </div>

                <div *ngIf="password.errors['missingLowercasedLetter']" i18n="@@form.errors.missingLowercasedLetter">
                  Your password must contain at least one lowercased character.
                </div>

                <div *ngIf="password.errors['missingNumber']" i18n="@@form.errors.missingNumber">
                  Your password must contain at least one number.
                </div>

                <div *ngIf="password.errors['forbiddenWord']" i18n="@@form.errors.forbiddenWord">
                  Your password must not contain obvious words.
                </div>
              </div>
            </div>
          </div>

          <div class="column is-12-mobile is-6-tablet">
            <div class="field">
              <label class="label" for="passwordConfirmation"><span i18n="@@signup.passwordConfirmation">Password
                  confirmation </span><span class="required-field">*</span></label>
              <p class="control has-icons-right">
                <input id="passwordConfirmation" class="input" type="password" formControlName="passwordConfirmation"
                  [ngClass]="{'has-error': passwordConfirmationError || fieldIsInvalid('passwordConfirmation'), 'is-valid': !passwordConfirmationError && fieldIsValid('passwordConfirmation')}">
                <span class="icon is-small is-right is-icon-success"
                  *ngIf="!passwordConfirmationError && fieldIsValid('passwordConfirmation')">
                  <span class="fas fa-check-circle"></span>
                </span>
                <span class="icon is-small is-right is-icon-warning"
                  *ngIf="passwordConfirmationError || fieldIsInvalid('passwordConfirmation')">
                  <span class="fas fa-exclamation-circle"></span>
                </span>
              </p>

              <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('passwordConfirmation')">
                <div *ngIf="passwordConfirmation.errors['required']" i18n="@@form.errors.missingConfirmationPassword">
                  You must confirm your password.
                </div>
              </div>
              <div class="form-incorrect-field-message" *ngIf="passwordConfirmationError">
                <div i18n="@@form.errors.passwordConfirmationError">
                  The password confirmation doesn't match with the password.
                </div>
              </div>
            </div>
          </div>

          <div class="column is-12-mobile is-6-tablet">
            <div class="field">
              <label class="label" for="entreprise" i18n="@@form.entreprise">Company</label>
              <p class="control">
                <input id="entreprise" class="input" type="text" formControlName="entreprise">
              </p>
            </div>
          </div>

          <div class="column is-12-mobile is-6-tablet">
            <div class="field">
              <label class="label" for="address" i18n="@@form.address">Address</label>
              <p class="control">
                <input id="address" class="input" type="text" formControlName="address">
              </p>
            </div>
          </div>

          <div class="column is-12-mobile is-6-tablet">
            <div class="field">
              <label class="label" for="zipcode" i18n="@@form.zipcode">Zipcode</label>
              <p class="control">
                <input id="zipcode" class="input" type="text" formControlName="zipcode">
              </p>
            </div>
          </div>

          <div class="column is-12-mobile is-6-tablet">
            <div class="field">
              <label class="label" for="city" i18n="@@form.city">City</label>
              <p class="control">
                <input id="city" class="input" type="text" formControlName="city">
              </p>
            </div>
          </div>

          <div class="column is-12-mobile is-6-tablet">
            <div class="field">
              <label class="label" for="country" i18n="@@form.country">Country</label>
              <p class="control">
                <input id="country" class="input" type="text" formControlName="country">
              </p>
            </div>
          </div>

          <div class="column is-12">
            <div class="field">
              <input id="acceptMessages" class="is-checkradio" type="checkbox" formControlName="acceptMessages">
              <label for="acceptMessages" class="label checkbox-label accept-messages-label"
                i18n="@@form.messagesAgreement">I agree to
                receive information</label>
              <p class="acceptMessagesInfo" i18n="@@form.acceptMessagesInfo">
                Check this box if you agree to receive information emails from Data about the operation of services,
                model
                changes, new formats, maintenance operations. Your data will not be sent to partners.
              </p>
            </div>
          </div>

          <div class="column is-12">
            <div class="field">
              <input id="cgu" class="is-checkradio" type="checkbox" formControlName="cgu">
              <label for="cgu" class="label checkbox-label">
                <p>
                  <span i18n="@@cgu.partOne">I accept the</span><a i18n="@@cgu.partTwo"
                    [routerLink]="['/', AppRoutes.cgu.uri]"> general terms of use.</a>
                  <span class="required-field">*</span>
                </p>
              </label>
              <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('cgu')">
                <div *ngIf="cgu.errors['required']" i18n="@@cgu.error">
                  You must accept the general terms of use.
                </div>
              </div>
            </div>
          </div>

          <div class="column is-12">
            <div class="field">
              <input id="consent" class="is-checkradio" type="checkbox" formControlName="consent">
              <label for="consent" class="label checkbox-label consent-label">
                <p>
                  <span i18n="@@consent.withoutCGU">I accept the processing of the information
                    entered in this form to respond to my request.</span><span class="required-field">*</span>
                </p>
              </label>
              <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('consent')">
                <div *ngIf="consent.errors['required']" i18n="@@consent.error">
                  You must accept the processing of the information entered in this form to
                  respond to your request.
                </div>
              </div>
              <p class="consent-text" i18n="@@consent.signup.text">
                According to French Law ≪ Informatique et Libertés ≫ concerning data processing and individual liberties,
                registration and use of your personal datas are necessary to answer your questions.
                You allow « data.grandlyon.com » to collect and use your datas by clicking the box « I accept the processing of the information entered in this form to respond to my request. ». Data collected are: e-mail, firstname, lastname, company, address, zipcode, city and country.
                Recipients of these personal datas are, with strict respect of goals mentionned above,
                responsible departements of Metropole de Lyon and its service providers.
                You have the right to access, correct and delete the personal data.
                When a consent is required for a processing, you have the right to revoke it.
                Under some regulary conditions, you have the right to ask for processing limitation or to get opposed to it.
                To exercise these rights, you can contact the Délégué à la Protection des Données by mail at :
                Métropole de Lyon – Délégué à la Protection des Données – Direction des Affaires Juridiques et de la Commande Publique – 20, rue du Lac – BP 33569 – 69505 Lyon Cedex 03
                or by form at : https://demarches.toodego.com/sve/proteger-mes-donnees-personnelles/.
                For any demand about collecting or processing of your personal datas, you can contact the Délégué à la Protection des Données (DPD), whose adress is mentionned above.
                For strong conflicts concerning your personal datas, you have the right to alert the CNIL [supervisory authority] which address is : Commission Nationale Informatique et Libertés, 3 place de Fontenoy 75007 Paris, 01 53 73 22 22, https://www.cnil.fr/fr/vous-souhaitez-contacter-la-cnil
              </p>
            </div>
          </div>
        </div>
      </div>
      <div class="column is-12 has-text-right">
        <div class="field">
          <div class="validation">
            <button type="submit" class="button button-gl" [ngClass]="{'is-loading': formDisabled}"
              [disabled]="formIsInvalid || formDisabled" i18n="@@signup.createAccount">Create an account</button>
          </div>
        </div>
      </div>
    </form>
  </div>
</div>
